import unittest

from pyGsi.proxylib import ProxyFactory 
from pyGsi.proxylib import ProxyFactoryException 

"""
TODO:
Generate test certificates and private key, that's not encrypted
to facilitate running these tests. Right now I just test this
with my ~/.globus/{usercert.pem,userkey.pem}. 
"""
GOOD_KEY_USAGE = "Digital Signature, Key Encipherment, Data Encipherment"
BAD_KEY_USAGE = "Digital Signature,Key Encipherment,Data Encipherment,Invalid Usage"


class ProxyFactoryTest(unittest.TestCase):
    def setUp(self):
        self._factory = ProxyFactory()

    def check_key_usage_pass(self):
        print "Testing setting proper key usage"
        try: 
            self._factory.set_key_usage(GOOD_KEY_USAGE)
            self._factory.generate()
        except:
            print "TEST FAILED"
        else:
            print "TEST PASSED"

    def check_key_usage_fail(self):
        print "Testing setting improper key usage"
        try:
            self._factory.set_key_usage(BAD_KEY_USAGE)
            self._factory.generate()
        except ProxyFactoryException:
            print "TEST PASSED"
        else:
            print "TEST FAILED"
            

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(ProxyFactoryTest, "check"))
    return suite 


def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__": main()
